#ifndef HTMLCalendarGeneratorH
#define HTMLCalendarGeneratorH

#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

typedef void __fastcall (__closure *TGetCalendarEvent)(System::TObject* Sender, TDateTime date, String &desc);


class PACKAGE THTMLCalendarGenerator : public TComponent
   {
   __published:
      __property int Month = {read = month, write = SetMonth};
      __property String Title = {read = title, write = SetTitle};
      __property int Year = {read = year, write = SetYear};

      __property TGetCalendarEvent OnGetEvent = {read = onGetEvent, write = onGetEvent};

   public:
      __fastcall THTMLCalendarGenerator(TComponent* Owner);
      virtual __fastcall ~THTMLCalendarGenerator();

      virtual void __fastcall SaveToFile(const String fileName);
      virtual void __fastcall SaveToStream(TStream *stream);

      __property String HTML = {read = GetHTML};

   protected:
      virtual void __fastcall Generate();

   private:
      String __fastcall GetHTML();
      void __fastcall SetMonth(int m);
      void __fastcall SetTitle(String t);
      void __fastcall SetYear(int y);

      int month, year;
      TGetCalendarEvent onGetEvent;
      TStringList *output;
      bool needsGenerating;
      String title;
   };


#endif   // HTMLCalendarGeneratorH

