#include <vcl.h>
#pragma hdrstop

#include "Main.h"

#pragma package(smart_init)
#pragma link "HTMLCalendarGenerator"
#pragma resource "*.dfm"

TMainForm *MainForm;

const int START_YEAR = 1999;
const int NUM_YEARS = 11;


__fastcall TMainForm::TMainForm(TComponent* Owner) : TForm(Owner)
   {
   Caption = Application->Title;

   // Fill in month combobox
   for (int i = 0; i < 12; i++)
      MonthCombo->Items->
         Add(LongMonthNames[i]);

   // Fill in year combobox
   for (int i = 0; i < NUM_YEARS; i++)
      YearCombo->Items->
         Add(START_YEAR + i);

   MonthCombo->ItemIndex =
      HTMLCalendarGenerator1->Month - 1;
   YearCombo->ItemIndex =
      HTMLCalendarGenerator1->Year
         - START_YEAR;
   }

void __fastcall TMainForm::CloseBtnClick(TObject *Sender)
   {
   Close();
   }

void __fastcall TMainForm::GenerateBtnClick(TObject *Sender)
   {
   TDateTime date(HTMLCalendarGenerator1->Year, HTMLCalendarGenerator1->Month, 1);
   SaveDialog->FileName = HTMLCalendarGenerator1->Title + FormatDateTime(" yyyy-mm", date) + ".htm";

   if (SaveDialog->Execute() == false) return;

   HTMLCalendarGenerator1->SaveToFile(SaveDialog->FileName);
   }

void __fastcall TMainForm
   ::MonthComboChange(TObject *Sender)
   {
   HTMLCalendarGenerator1->Month
      = MonthCombo->ItemIndex + 1;
   }

void __fastcall TMainForm
   ::YearComboChange(TObject *Sender)
   {
   HTMLCalendarGenerator1->Year
      = YearCombo->ItemIndex + START_YEAR;
   }

void __fastcall TMainForm
   ::HTMLCalendarGenerator1GetEvent(
   TObject *Sender, TDateTime date,
   AnsiString &desc)
   {
   unsigned short y, m, d;
   date.DecodeDate(&y, &m, &d);

   if (d == 1)
      desc = "The first day of the month";
   else if (d == 5)
      desc = "To subscribe <a href="
      "'http://www.Reisdorph.com'>"
      "click here.</a>";
   else if (d == 13)
      desc = "<img border='0' src='http://mark/Wiseman/Data/Pics/Pic001.jpg'>";
//         "This event<br>has two lines";
   else if (d == 22)
      desc = "Some <b>bold</b> text";
   else if (d == 31)
      desc = "This month has 31 days.";
   }

