
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <dlgs.h>
#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void NavigateToFolder(
   TOpenDialog& OpenDialog,
   AnsiString folder_name,
   int folder_csidl = 0
  )
{
  if (folder_csidl != 0)
  {
    // retrieve the path of the
    // specified special folder
    TCHAR specialfolder_name[MAX_PATH];
    SHGetSpecialFolderPath(
      OpenDialog.Handle,
      specialfolder_name,
      folder_csidl, false
      );
    folder_name = specialfolder_name;
  }

  if (folder_name.Length() != 0)
  {
    // grab a handle to the OpenAs dialog
    const HWND hOpenDlg =
      GetParent(OpenDialog.Handle);

    // grab a handle to the explorer-pane
    // list view's parent window
    const HWND hShellView = FindWindowEx(
      hOpenDlg, 0, "SHELLDLL_DefView", ""
      );

    // grab a handle to the
    // explorer-pane list view
    const HWND hListView = FindWindowEx(
       hShellView, 0, WC_LISTVIEW, ""
       );
    if (hListView)
    {
      // deselect all items
      LV_ITEM lvi = {LVIF_STATE};
      lvi.stateMask = LVIS_SELECTED;
      // NOTE: because lvi.state = 0,
      // this code will deselect
      SNDMSG(
         hListView, LVM_SETITEMSTATE,
         -1, // all items
         reinterpret_cast<LPARAM>(&lvi)
         );

      // grab a handle to the "File name"
      // edit control
      const HWND hFileEdit =
        GetDlgItem(hOpenDlg, edt1);

      // retrieve a copy of the "File
      // name" edit's current text
      TCHAR old_text[MAX_PATH];
      GetWindowText(
        hFileEdit, old_text, MAX_PATH
        );

      // change the "File name" edit's
      // text to the desired path
      SNDMSG(
        hFileEdit, WM_SETREDRAW, false, 0
        );
      SetWindowText(
        hFileEdit, folder_name.c_str()
        );
      SNDMSG(
        hFileEdit, WM_SETREDRAW, true, 0
        );

      // click the "Open" button to
      // change to the target folder
      const HWND hOKButton =
        GetDlgItem(hOpenDlg, IDOK);
      SNDMSG(hOKButton, BM_CLICK, 0, 0);

      // restore the "File name"
      // edit's text
      SetWindowText(hFileEdit, old_text);
    }
  }
}

void TForm1::NavigateTo(int folder_csidl)
{
  NavigateToFolder(
    *OpenDialogEx1, "", folder_csidl
    );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  OpenDialogEx1->ChildWinLeft = Form2->NavPanel;
  if (OpenDialogEx1->Execute())
  {
  }
}
//---------------------------------------------------------------------------


